# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.13
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from pypureclient.flasharray.FA_2_13.models.fixed_reference import FixedReference


class AppNode(BaseModel):
    """
    An individual node of a Purity app. Nodes are indexed starting at `0`.
    """
    app: Optional[FixedReference] = Field(default=None, description="A reference to the app of which this node is a part.")
    index: Optional[StrictInt] = Field(default=None, description="An index that represents this node.")
    status: Optional[StrictStr] = Field(default=None, description="The node status. Possible values are `starting`, `healthy`, `unhealthy`, `critical`, `stopping`, and `disabled`.")
    version: Optional[StrictStr] = Field(default=None, description="The node version.")
    vnc: Optional[conlist(StrictStr)] = Field(default=None, description="The VNC information used to access this node if VNC is enabled.")
    __properties = ["app", "index", "status", "version", "vnc"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "index",
                "status",
                "version",
                "vnc",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of app
        if _include_in_dict('app', include_readonly, excluded_fields, none_fields):
            _dict['app'] = self.app.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> AppNode:
        """Create an instance of AppNode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> AppNode:
        """Create an instance of AppNode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AppNode.parse_obj(obj)

        _obj = AppNode.construct(_fields_set=None, **{
            "app": FixedReference.from_dict(obj.get("app")) if obj.get("app") is not None else None,
            "index": obj.get("index"),
            "status": obj.get("status"),
            "version": obj.get("version"),
            "vnc": obj.get("vnc")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

