# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field
from pypureclient.flasharray.FA_2_17.models.reference_no_id import ReferenceNoId


class Saml2SsoSpCredential(BaseModel):
    """
    Saml2SsoSpCredential
    """
    decryption_credential: Optional[ReferenceNoId] = Field(default=None, description="The credential used by the service provider to decrypt encrypted SAML assertions from the identity provider. The credential is managed by the `certificates` endpoint and `purecert` CLI commands.")
    signing_credential: Optional[ReferenceNoId] = Field(default=None, description="The credential used by the service provider to sign SAML requests. The credential is managed by the `certificates` endpoint and `purecert` CLI commands.")
    __properties = ["decryption_credential", "signing_credential"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of decryption_credential
        if _include_in_dict('decryption_credential', include_readonly, excluded_fields, none_fields):
            _dict['decryption_credential'] = self.decryption_credential.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of signing_credential
        if _include_in_dict('signing_credential', include_readonly, excluded_fields, none_fields):
            _dict['signing_credential'] = self.signing_credential.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Saml2SsoSpCredential:
        """Create an instance of Saml2SsoSpCredential from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Saml2SsoSpCredential:
        """Create an instance of Saml2SsoSpCredential from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Saml2SsoSpCredential.parse_obj(obj)

        _obj = Saml2SsoSpCredential.construct(_fields_set=None, **{
            "decryption_credential": ReferenceNoId.from_dict(obj.get("decryption_credential")) if obj.get("decryption_credential") is not None else None,
            "signing_credential": ReferenceNoId.from_dict(obj.get("signing_credential")) if obj.get("signing_credential") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

