# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt


class RetentionPolicy(BaseModel):
    """
    The snapshot retention policy.
    """
    all_for_sec: Optional[StrictInt] = Field(default=None, description="The length of time to keep the specified snapshots. Measured in seconds. Prior to 6.8.2 the range of 60 to 34560000 is accepted. In 6.8.2 and onwards the range of 60 to 2147483647 is accepted.")
    days: Optional[StrictInt] = Field(default=None, description="The number of days to keep the snapshots after the `all_for_sec` period has passed. Prior to 6.6.4 the range of 0 to 4000 is accepted. In 6.6.4 and onwards the range of 0 to 2147483647 is accepted.")
    per_day: Optional[StrictInt] = Field(default=None, description="The number of snapshots to keep per day after the `all_for_sec` period has passed. Prior to 6.8.2 the range of 0 to 1440 is accepted. In 6.8.2 and onwards the range of 0 to 2147483647 is accepted.")
    __properties = ["all_for_sec", "days", "per_day"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> RetentionPolicy:
        """Create an instance of RetentionPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> RetentionPolicy:
        """Create an instance of RetentionPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RetentionPolicy.parse_obj(obj)

        _obj = RetentionPolicy.construct(_fields_set=None, **{
            "all_for_sec": obj.get("all_for_sec"),
            "days": obj.get("days"),
            "per_day": obj.get("per_day")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

