# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from pypureclient.flasharray.FA_2_20.models.saml2_sso_idp import Saml2SsoIdp
from pypureclient.flasharray.FA_2_20.models.saml2_sso_sp_credential import Saml2SsoSpCredential


class Saml2SsoPatch(BaseModel):
    """
    Saml2SsoPatch
    """
    array_url: Optional[StrictStr] = Field(default=None, description="The URL of the array.")
    idp: Optional[Saml2SsoIdp] = None
    sp: Optional[Saml2SsoSpCredential] = Field(default=None, description="Properties specific to the service provider.")
    enabled: Optional[StrictBool] = Field(default=None, description="If set to `true`, the SAML2 SSO configuration is enabled.")
    __properties = ["array_url", "idp", "sp", "enabled"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of idp
        if _include_in_dict('idp', include_readonly, excluded_fields, none_fields):
            _dict['idp'] = self.idp.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of sp
        if _include_in_dict('sp', include_readonly, excluded_fields, none_fields):
            _dict['sp'] = self.sp.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Saml2SsoPatch:
        """Create an instance of Saml2SsoPatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Saml2SsoPatch:
        """Create an instance of Saml2SsoPatch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Saml2SsoPatch.parse_obj(obj)

        _obj = Saml2SsoPatch.construct(_fields_set=None, **{
            "array_url": obj.get("array_url"),
            "idp": Saml2SsoIdp.from_dict(obj.get("idp")) if obj.get("idp") is not None else None,
            "sp": Saml2SsoSpCredential.from_dict(obj.get("sp")) if obj.get("sp") is not None else None,
            "enabled": obj.get("enabled")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

