# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.22
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr
from pypureclient.flasharray.FA_2_22.models.snmp_v2c import SnmpV2c
from pypureclient.flasharray.FA_2_22.models.snmp_v3 import SnmpV3


class SnmpAgent(BaseModel):
    """
    SnmpAgent
    """
    name: Optional[StrictStr] = Field(default=None, description="A locally unique, system-generated name. The name cannot be modified.")
    engine_id: Optional[constr(strict=True, max_length=32)] = Field(default=None, description="The administration domain unique name of an SNMP agent.")
    v2c: Optional[SnmpV2c] = None
    v3: Optional[SnmpV3] = None
    version: Optional[StrictStr] = Field(default=None, description="Version of the SNMP protocol to be used by Purity//FA in communications with the specified manager. Valid values are `v2c` and `v3`.")
    __properties = ["name", "engine_id", "v2c", "v3", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "engine_id",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of v2c
        if _include_in_dict('v2c', include_readonly, excluded_fields, none_fields):
            _dict['v2c'] = self.v2c.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of v3
        if _include_in_dict('v3', include_readonly, excluded_fields, none_fields):
            _dict['v3'] = self.v3.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SnmpAgent:
        """Create an instance of SnmpAgent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SnmpAgent:
        """Create an instance of SnmpAgent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SnmpAgent.parse_obj(obj)

        _obj = SnmpAgent.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "engine_id": obj.get("engine_id"),
            "v2c": SnmpV2c.from_dict(obj.get("v2c")) if obj.get("v2c") is not None else None,
            "v3": SnmpV3.from_dict(obj.get("v3")) if obj.get("v3") is not None else None,
            "version": obj.get("version")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

