# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.23
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from pypureclient.flasharray.FA_2_23.models.throttle import Throttle


class ArrayConnection(BaseModel):
    """
    ArrayConnection
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified and cannot refer to another resource.")
    name: Optional[StrictStr] = Field(default=None, description="A locally unique, system-generated name. The name cannot be modified.")
    management_address: Optional[StrictStr] = Field(default=None, description="Management IP address or FQDN of the target array.")
    replication_addresses: Optional[conlist(StrictStr)] = Field(default=None, description="IP addresses of the target arrays when `replication_transport` is `ip`. WWNs of the target arrays when `replication_transport` is `fc`.")
    replication_transport: Optional[StrictStr] = Field(default=None, description="The protocol used to transport data between the local array and the remote array. Valid values are `ip` and `fc`. The default is `ip`.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the connection. Valid values are `connected`, `connecting`, `partially_connected`, and `unbalanced`. A status of `connected` indicates that arrays are communicating. A status of `connecting` indicates that the array is trying to establish a connection. A status of `partially_connected` indicates that some replication addresses are communicating but others are not. A status of `unbalanced` indicates that the arrays are communicating, but the set of paths is either not redundant or not symmetric.")
    throttle: Optional[Throttle] = None
    type: Optional[StrictStr] = Field(default=None, description="The type of replication. Valid values are `async-replication` and `sync-replication`.")
    version: Optional[StrictStr] = Field(default=None, description="The version of the target array.")
    __properties = ["id", "name", "management_address", "replication_addresses", "replication_transport", "status", "throttle", "type", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of throttle
        if _include_in_dict('throttle', include_readonly, excluded_fields, none_fields):
            _dict['throttle'] = self.throttle.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> ArrayConnection:
        """Create an instance of ArrayConnection from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> ArrayConnection:
        """Create an instance of ArrayConnection from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ArrayConnection.parse_obj(obj)

        _obj = ArrayConnection.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "management_address": obj.get("management_address"),
            "replication_addresses": obj.get("replication_addresses"),
            "replication_transport": obj.get("replication_transport"),
            "status": obj.get("status"),
            "throttle": Throttle.from_dict(obj.get("throttle")) if obj.get("throttle") is not None else None,
            "type": obj.get("type"),
            "version": obj.get("version")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

