# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.29
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from pypureclient.flasharray.FA_2_29.models.pod_performance_replication import PodPerformanceReplication


class PodPerformanceReplicationResponse(BaseModel):
    """
    PodPerformanceReplicationResponse
    """
    items: Optional[conlist(PodPerformanceReplication)] = Field(default=None, description="A list of pod performance replication objects.")
    total: Optional[conlist(PodPerformanceReplication)] = Field(default=None, description="The aggregate value of all items after filtering. For real-time performance, the values are aggregated for the latest timestamp. For historical performance, the values are aggregated for each timestamp from `start_time` to `end_time`. When applicable, the average value is displayed instead. The values are displayed for each field if meaningful.")
    __properties = ["items", "total"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        if _include_in_dict('items', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['items'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in total (list)
        if _include_in_dict('total', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.total:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['total'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> PodPerformanceReplicationResponse:
        """Create an instance of PodPerformanceReplicationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> PodPerformanceReplicationResponse:
        """Create an instance of PodPerformanceReplicationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PodPerformanceReplicationResponse.parse_obj(obj)

        _obj = PodPerformanceReplicationResponse.construct(_fields_set=None, **{
            "items": [PodPerformanceReplication.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None,
            "total": [PodPerformanceReplication.from_dict(_item) for _item in obj.get("total")] if obj.get("total") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

