# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.36
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist


class PolicyrulealertwatcherpostRules(BaseModel):
    """
    PolicyrulealertwatcherpostRules
    """
    email: Optional[StrictStr] = Field(default=None, description="The email address that will receive the alert notification emails.")
    excluded_codes: Optional[conlist(StrictInt)] = Field(default=None, description="An alert with one of these codes will not have emails sent to the recipient. Cannot be specified with `include_codes`. If specified while `include_codes` is already set, `include_codes` will be cleared. Use \"\" to clear. If both `exclude_codes` and `include_codes` are cleared, defaults to an empty list for `exclude_codes`.")
    included_codes: Optional[conlist(StrictInt)] = Field(default=None, description="An alert must have one of these codes in order for emails to be sent to the recipient. Cannot be specified with `exclude_codes`. If specified while `exclude_codes` is already set, `exclude_codes` will be cleared. Use \"\" to clear. If both `exclude_codes` and `include_codes` are cleared, defaults to an empty list for `exclude_codes`.")
    minimum_notification_severity: Optional[StrictStr] = Field(default=None, description="The minimum severity that an alert must have in order for emails to be sent to the recipient. Possible values include `info`, `warning`, and `critical`. If not specified, defaults to `info`.")
    __properties = ["email", "excluded_codes", "included_codes", "minimum_notification_severity"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> PolicyrulealertwatcherpostRules:
        """Create an instance of PolicyrulealertwatcherpostRules from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> PolicyrulealertwatcherpostRules:
        """Create an instance of PolicyrulealertwatcherpostRules from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PolicyrulealertwatcherpostRules.parse_obj(obj)

        _obj = PolicyrulealertwatcherpostRules.construct(_fields_set=None, **{
            "email": obj.get("email"),
            "excluded_codes": obj.get("excluded_codes"),
            "included_codes": obj.get("included_codes"),
            "minimum_notification_severity": obj.get("minimum_notification_severity")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

