# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.38
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr


class SoftwareBundle(BaseModel):
    """
    SoftwareBundle
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    created: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Creation time in milliseconds since the UNIX epoch.")
    details: Optional[StrictStr] = Field(default=None, description="The detailed reason for the `status`.")
    download_progress: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The progress of the download. Displayed in decimal format.")
    source: Optional[StrictStr] = Field(default=None, description="The location of the upgrade bundle.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the software bundle. Valid values are `downloading`, `failed`, `ready`, and `verifying`. A status of `downloading` indicates that the array is downloading the upgrade bundle. A status of `failed` indicates that the array has failed to download the upgrade bundle. A status of `ready` indicates that the upgrade bundle is ready to be installed. A status of `verifying` indicates that the array is verifying the upgrade bundle.")
    __properties = ["id", "created", "details", "download_progress", "source", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SoftwareBundle:
        """Create an instance of SoftwareBundle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SoftwareBundle:
        """Create an instance of SoftwareBundle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SoftwareBundle.parse_obj(obj)

        _obj = SoftwareBundle.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "created": obj.get("created"),
            "details": obj.get("details"),
            "download_progress": obj.get("download_progress"),
            "source": obj.get("source"),
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

