# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.39
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr


class SoftwarePatch(BaseModel):
    """
    SoftwarePatch
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the resource. The name cannot be modified.")
    alert_code: Optional[StrictInt] = Field(default=None, description="Alert code for the Software Patch. This code is used to uniquely identify the Software Patch.")
    description: Optional[StrictStr] = Field(default=None, description="The detailed description of the patch.")
    details: Optional[StrictStr] = Field(default=None, description="The detailed reason for the `status`.")
    ha_reduction_required: Optional[StrictBool] = Field(default=None, description="If set to `true`, indicates reduction in high availability is required for Software Patch installation. If set to `false`, indicates such a reduction is not required.")
    progress: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The progress of the software patch installation, displayed in decimal format.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the software patch installation. Valid values are `available`, `downloaded`, `downloading`, `download_failed`, `installing`, `installed`, `failed`, and `not_applicable`. A status of `available` indicates that the patch is available for download. A status of `downloaded` indicates that the patch has been downloaded and will be installed. A status of `downloading` indicates that the patch is currently downloading. A status of `download_failed` indicates that the download of the patch failed. A status of `installing` indicates that the patch is currently being installed. A status of `installed` indicates that the patch has been installed. A status of `failed` indicates that the patch failed to be installed. A status of `not_applicable` indicates the patch does not need to be installed on the array.")
    __properties = ["id", "name", "alert_code", "description", "details", "ha_reduction_required", "progress", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SoftwarePatch:
        """Create an instance of SoftwarePatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SoftwarePatch:
        """Create an instance of SoftwarePatch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SoftwarePatch.parse_obj(obj)

        _obj = SoftwarePatch.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "alert_code": obj.get("alert_code"),
            "description": obj.get("description"),
            "details": obj.get("details"),
            "ha_reduction_required": obj.get("ha_reduction_required"),
            "progress": obj.get("progress"),
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

