# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.39
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool
from pypureclient.flasharray.FA_2_39.models.fixed_reference import FixedReference


class VchostConnection(BaseModel):
    """
    VchostConnection
    """
    all_vchosts: Optional[StrictBool] = Field(default=False, description="If set to `true`, the storage container represented by the protocol endpoint is accessible to all vchosts. If set to `false`, the storage container represented by the protocol endpoint is only accesible to the vchosts that have explicit vchost-connections to this protocol endpoint. The default is `false`.")
    protocol_endpoint: Optional[FixedReference] = Field(default=None, description="A reference to the protocol endpoint, representing a storage container that vCenter can use.")
    vchost: Optional[FixedReference] = Field(default=None, description="For vchost-connections, a vchost represents a vCenter. By connecting to a protocol endpoint, the corresponding vCenter gets the access to the storage container represented by this protocol endpoint. The vchost name should be null if `all_vchosts` is set to `true`, which means the storage container is accessible to all vchosts.")
    __properties = ["all_vchosts", "protocol_endpoint", "vchost"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of protocol_endpoint
        if _include_in_dict('protocol_endpoint', include_readonly, excluded_fields, none_fields):
            _dict['protocol_endpoint'] = self.protocol_endpoint.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of vchost
        if _include_in_dict('vchost', include_readonly, excluded_fields, none_fields):
            _dict['vchost'] = self.vchost.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> VchostConnection:
        """Create an instance of VchostConnection from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> VchostConnection:
        """Create an instance of VchostConnection from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VchostConnection.parse_obj(obj)

        _obj = VchostConnection.construct(_fields_set=None, **{
            "all_vchosts": obj.get("all_vchosts") if obj.get("all_vchosts") is not None else False,
            "protocol_endpoint": FixedReference.from_dict(obj.get("protocol_endpoint")) if obj.get("protocol_endpoint") is not None else None,
            "vchost": FixedReference.from_dict(obj.get("vchost")) if obj.get("vchost") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

