# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr
from pypureclient.flasharray.FA_2_4.models.qos import Qos
from pypureclient.flasharray.FA_2_4.models.space import Space


class VolumeCommon(BaseModel):
    """
    VolumeCommon
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified and cannot refer to another resource.")
    name: Optional[StrictStr] = Field(default=None, description="A user-specified name. The name must be locally unique and can be changed.")
    connection_count: Optional[StrictInt] = Field(default=None, description="The total number of hosts and host groups connected to the volume.")
    created: Optional[StrictInt] = Field(default=None, description="The volume creation time. Measured in milliseconds since the UNIX epoch.")
    destroyed: Optional[StrictBool] = Field(default=None, description="Returns a value of `true` if the volume has been destroyed and is pending eradication. The `time_remaining` value displays the amount of time left until the destroyed volume is permanently eradicated. Before the `time_remaining` period has elapsed, the destroyed volume can be recovered by setting `destroyed=false`. Once the `time_remaining` period has elapsed, the volume is permanently eradicated and can no longer be recovered.")
    host_encryption_key_status: Optional[StrictStr] = Field(default=None, description="The host encryption key status for this volume. Possible values include `none`, `detected`, and `fetched`.")
    provisioned: Optional[StrictInt] = Field(default=None, description="The virtual size of the volume. Measured in bytes and must be a multiple of 512. The maximum size is 4503599627370496 (4PB)")
    qos: Optional[Qos] = Field(default=None, description="Displays QoS limit information.")
    serial: Optional[StrictStr] = Field(default=None, description="A globally unique serial number generated by the system when the volume is created.")
    space: Optional[Space] = Field(default=None, description="Displays size and space consumption information.")
    time_remaining: Optional[StrictInt] = Field(default=None, description="The amount of time left until the destroyed volume is permanently eradicated. Measured in milliseconds. Before the `time_remaining` period has elapsed, the destroyed volume can be recovered by setting `destroyed=false`.")
    __properties = ["id", "name", "connection_count", "created", "destroyed", "host_encryption_key_status", "provisioned", "qos", "serial", "space", "time_remaining"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "connection_count",
                "created",
                "host_encryption_key_status",
                "serial",
                "time_remaining",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of qos
        if _include_in_dict('qos', include_readonly, excluded_fields, none_fields):
            _dict['qos'] = self.qos.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of space
        if _include_in_dict('space', include_readonly, excluded_fields, none_fields):
            _dict['space'] = self.space.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> VolumeCommon:
        """Create an instance of VolumeCommon from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> VolumeCommon:
        """Create an instance of VolumeCommon from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VolumeCommon.parse_obj(obj)

        _obj = VolumeCommon.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "connection_count": obj.get("connection_count"),
            "created": obj.get("created"),
            "destroyed": obj.get("destroyed"),
            "host_encryption_key_status": obj.get("host_encryption_key_status"),
            "provisioned": obj.get("provisioned"),
            "qos": Qos.from_dict(obj.get("qos")) if obj.get("qos") is not None else None,
            "serial": obj.get("serial"),
            "space": Space.from_dict(obj.get("space")) if obj.get("space") is not None else None,
            "time_remaining": obj.get("time_remaining")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

