# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.40
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from pypureclient.flasharray.FA_2_40.models.directory_export import DirectoryExport


class DirectoryExportGetResponse(BaseModel):
    """
    DirectoryExportGetResponse
    """
    continuation_token: Optional[StrictStr] = Field(default=None, description="Continuation token that can be provided in the `continuation_token` query param to get the next page of data. If you use the continuation token to page through data you are guaranteed to get all items exactly once regardless of how items are modified. If an item is added or deleted during the pagination then it may or may not be returned. The continuation token is generated if the limit is less than the remaining number of items, and the default sort is used (no sort is specified).")
    more_items_remaining: Optional[StrictBool] = Field(default=None, description="Returns a value of `true` if subsequent items can be retrieved.")
    total_item_count: Optional[StrictInt] = Field(default=None, description="The total number of records after applying all filter query parameters. The `total_item_count` will be calculated if and only if the corresponding query parameter `total_item_count` is set to `true`. If this query parameter is not set or set to `false`, a value of `null` will be returned.")
    items: Optional[conlist(DirectoryExport)] = Field(default=None, description="Displays a list of all items after filtering. The values are displayed for each name if meaningful.")
    __properties = ["continuation_token", "more_items_remaining", "total_item_count", "items"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        if _include_in_dict('items', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['items'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> DirectoryExportGetResponse:
        """Create an instance of DirectoryExportGetResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> DirectoryExportGetResponse:
        """Create an instance of DirectoryExportGetResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DirectoryExportGetResponse.parse_obj(obj)

        _obj = DirectoryExportGetResponse.construct(_fields_set=None, **{
            "continuation_token": obj.get("continuation_token"),
            "more_items_remaining": obj.get("more_items_remaining"),
            "total_item_count": obj.get("total_item_count"),
            "items": [DirectoryExport.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

