# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.40
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from pypureclient.flasharray.FA_2_40.models.reference import Reference
from pypureclient.flasharray.FA_2_40.models.software_installation_steps_checks import SoftwareInstallationStepsChecks


class SoftwareInstallationStep(BaseModel):
    """
    SoftwareInstallationStep
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the resource. The name cannot be modified.")
    end_time: Optional[StrictInt] = Field(default=None, description="End time in milliseconds since the UNIX epoch.")
    start_time: Optional[StrictInt] = Field(default=None, description="Start time in milliseconds since the UNIX epoch.")
    checks: Optional[conlist(SoftwareInstallationStepsChecks)] = Field(default=None, description="A list of checks in this upgrade step.")
    description: Optional[StrictStr] = Field(default=None, description="Detailed description of the step.")
    details: Optional[StrictStr] = Field(default=None, description="Detailed result of the step used to diagnose step failures.")
    hop_version: Optional[StrictStr] = Field(default=None, description="The version to which the current hop is upgrading.")
    installation: Optional[Reference] = Field(default=None, description="Referenced `software-installation` to which the step belongs.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the step. Valid values are `running` and `finished`. A status of `running` indicates that the step has not finished. A status of `finished` indicates that the check has finished.")
    __properties = ["id", "name", "end_time", "start_time", "checks", "description", "details", "hop_version", "installation", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in checks (list)
        if _include_in_dict('checks', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.checks:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['checks'] = _items
        # override the default output from pydantic by calling `to_dict()` of installation
        if _include_in_dict('installation', include_readonly, excluded_fields, none_fields):
            _dict['installation'] = self.installation.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SoftwareInstallationStep:
        """Create an instance of SoftwareInstallationStep from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SoftwareInstallationStep:
        """Create an instance of SoftwareInstallationStep from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SoftwareInstallationStep.parse_obj(obj)

        _obj = SoftwareInstallationStep.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "end_time": obj.get("end_time"),
            "start_time": obj.get("start_time"),
            "checks": [SoftwareInstallationStepsChecks.from_dict(_item) for _item in obj.get("checks")] if obj.get("checks") is not None else None,
            "description": obj.get("description"),
            "details": obj.get("details"),
            "hop_version": obj.get("hop_version"),
            "installation": Reference.from_dict(obj.get("installation")) if obj.get("installation") is not None else None,
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

