# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.41
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt


class Transfer(BaseModel):
    """
    Transfer
    """
    completed: Optional[StrictInt] = Field(default=None, description="The timestamp of when the snapshot replication process completed. Measured in milliseconds since the UNIX epoch.")
    data_transferred: Optional[StrictInt] = Field(default=None, description="The number of bytes transferred from the source to the target as part of the replication process. Measured in bytes.")
    destroyed: Optional[StrictBool] = Field(default=None, description="Returns a value of `true` if the snapshot has been destroyed and is pending eradication. The destroyed snapshot can be recovered by setting `destroyed=false`. Once the eradication pending period has elapsed, the snapshot is permanently eradicated and can no longer be recovered.")
    physical_bytes_written: Optional[StrictInt] = Field(default=None, description="The amount of physical/logical data written to the target due to replication. Measured in bytes.")
    progress: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The percentage progress of the snapshot transfer from the source array to the target. Displayed in decimal format.")
    started: Optional[StrictInt] = Field(default=None, description="The timestamp of when the snapshot replication process started. Measured in milliseconds since the UNIX epoch.")
    __properties = ["completed", "data_transferred", "destroyed", "physical_bytes_written", "progress", "started"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "completed",
                "data_transferred",
                "physical_bytes_written",
                "progress",
                "started",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Transfer:
        """Create an instance of Transfer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Transfer:
        """Create an instance of Transfer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Transfer.parse_obj(obj)

        _obj = Transfer.construct(_fields_set=None, **{
            "completed": obj.get("completed"),
            "data_transferred": obj.get("data_transferred"),
            "destroyed": obj.get("destroyed"),
            "physical_bytes_written": obj.get("physical_bytes_written"),
            "progress": obj.get("progress"),
            "started": obj.get("started")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

