# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.43
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt
from pypureclient.flasharray.FA_2_43.models.workload_placement_recommendation_projection import WorkloadPlacementRecommendationProjection


class WorkloadPlacementRecommendationTargetCapacityUsedProjections(BaseModel):
    """
    Projections for the capacity consumed by customer data.
    """
    days_until_full: Optional[StrictInt] = Field(default=None, description="The number of days until the target is at full capacity.")
    projection: Optional[WorkloadPlacementRecommendationProjection] = Field(default=None, description="The projection of the used capacity, assuming the workload is provisioned on this target.")
    __properties = ["days_until_full", "projection"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of projection
        if _include_in_dict('projection', include_readonly, excluded_fields, none_fields):
            _dict['projection'] = self.projection.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> WorkloadPlacementRecommendationTargetCapacityUsedProjections:
        """Create an instance of WorkloadPlacementRecommendationTargetCapacityUsedProjections from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> WorkloadPlacementRecommendationTargetCapacityUsedProjections:
        """Create an instance of WorkloadPlacementRecommendationTargetCapacityUsedProjections from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WorkloadPlacementRecommendationTargetCapacityUsedProjections.parse_obj(obj)

        _obj = WorkloadPlacementRecommendationTargetCapacityUsedProjections.construct(_fields_set=None, **{
            "days_until_full": obj.get("days_until_full"),
            "projection": WorkloadPlacementRecommendationProjection.from_dict(obj.get("projection")) if obj.get("projection") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

