# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr
from pypureclient.flasharray.FA_2_6.models.fixed_reference import FixedReference
from pypureclient.flasharray.FA_2_6.models.fixed_reference_no_id import FixedReferenceNoId


class RemoteProtectionGroupSnapshot(BaseModel):
    """
    RemoteProtectionGroupSnapshot
    """
    name: Optional[StrictStr] = Field(default=None, description="A locally unique, system-generated name. The name cannot be modified.")
    created: Optional[StrictInt] = Field(default=None, description="Creation time of the snapshot on the original source of the snapshot. Measured in milliseconds since the UNIX epoch.")
    destroyed: Optional[StrictBool] = Field(default=None, description="Destroyed and pending eradication? If not specified, defaults to false.")
    is_local: Optional[StrictBool] = Field(default=None, description="Whether or not this remote protection group snapshot is replicated from the current array.")
    remote: Optional[FixedReference] = Field(default=None, description="The offload target where the remote protection group snapshot is located.")
    source: Optional[FixedReferenceNoId] = Field(default=None, description="The original protection group from which this snapshot was taken.")
    suffix: Optional[StrictStr] = Field(default=None, description="The suffix that is appended to the `source_name` value to generate the full remote protection group snapshot name in the form `PGROUP.SUFFIX`. If the suffix is not specified, the system constructs the snapshot name in the form `PGROUP.NNN`, where `PGROUP` is the protection group name, and `NNN` is a monotonically increasing number.")
    time_remaining: Optional[StrictInt] = Field(default=None, description="Milliseconds remaining until eradication, if the snapshot has been destroyed.")
    __properties = ["name", "created", "destroyed", "is_local", "remote", "source", "suffix", "time_remaining"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "created",
                "is_local",
                "time_remaining",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of remote
        if _include_in_dict('remote', include_readonly, excluded_fields, none_fields):
            _dict['remote'] = self.remote.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of source
        if _include_in_dict('source', include_readonly, excluded_fields, none_fields):
            _dict['source'] = self.source.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> RemoteProtectionGroupSnapshot:
        """Create an instance of RemoteProtectionGroupSnapshot from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> RemoteProtectionGroupSnapshot:
        """Create an instance of RemoteProtectionGroupSnapshot from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RemoteProtectionGroupSnapshot.parse_obj(obj)

        _obj = RemoteProtectionGroupSnapshot.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "created": obj.get("created"),
            "destroyed": obj.get("destroyed"),
            "is_local": obj.get("is_local"),
            "remote": FixedReference.from_dict(obj.get("remote")) if obj.get("remote") is not None else None,
            "source": FixedReferenceNoId.from_dict(obj.get("source")) if obj.get("source") is not None else None,
            "suffix": obj.get("suffix"),
            "time_remaining": obj.get("time_remaining")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

