# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.14, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.14
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from pypureclient.flashblade.FB_2_14.models.fixed_reference_name_only import FixedReferenceNameOnly
from pypureclient.flashblade.FB_2_14.models.user_no_id import UserNoId


class FileSession(BaseModel):
    """
    FileSession
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    authentication: Optional[StrictStr] = Field(default=None, description="Describes how was the user authenticated. Valid values include `KRB` and `NTLMv2`.")
    client: Optional[FixedReferenceNameOnly] = Field(default=None, description="Client that holds the session.")
    connection_time: Optional[StrictInt] = Field(default=None, description="Connection time in milliseconds since UNIX epoch.")
    idle_time: Optional[StrictInt] = Field(default=None, description="Duration in milliseconds that indicates how long the session has been idle.")
    opens: Optional[StrictInt] = Field(default=None, description="Number of opens for the given session.")
    port: Optional[StrictInt] = Field(default=None, description="Port number the client is connected from.")
    protocol: Optional[StrictStr] = Field(default=None, description="The protocol utilized for obtaining and managing the session. Valid values include `nfs` and `smb`.")
    time: Optional[StrictInt] = Field(default=None, description="Current time in milliseconds since UNIX epoch.")
    user: Optional[UserNoId] = Field(default=None, description="The user who has created the session.")
    __properties = ["name", "authentication", "client", "connection_time", "idle_time", "opens", "port", "protocol", "time", "user"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "authentication",
                "protocol",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of client
        if _include_in_dict('client', include_readonly, excluded_fields, none_fields):
            _dict['client'] = self.client.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of user
        if _include_in_dict('user', include_readonly, excluded_fields, none_fields):
            _dict['user'] = self.user.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> FileSession:
        """Create an instance of FileSession from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> FileSession:
        """Create an instance of FileSession from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FileSession.parse_obj(obj)

        _obj = FileSession.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "authentication": obj.get("authentication"),
            "client": FixedReferenceNameOnly.from_dict(obj.get("client")) if obj.get("client") is not None else None,
            "connection_time": obj.get("connection_time"),
            "idle_time": obj.get("idle_time"),
            "opens": obj.get("opens"),
            "port": obj.get("port"),
            "protocol": obj.get("protocol"),
            "time": obj.get("time"),
            "user": UserNoId.from_dict(obj.get("user")) if obj.get("user") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

