# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from pypureclient.flashblade.FB_2_17.models.bucket_access_policy_rule_principal import BucketAccessPolicyRulePrincipal
from pypureclient.flashblade.FB_2_17.models.fixed_reference import FixedReference
from pypureclient.flashblade.FB_2_17.models.reference import Reference


class BucketAccessPolicyRuleWithContext(BaseModel):
    """
    BucketAccessPolicyRuleWithContext
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    actions: Optional[conlist(StrictStr)] = Field(default=None, description="The list of actions granted by this rule. Each included action may restrict other properties of the rule. The only currently supported action is `s3:GetObject`.")
    effect: Optional[StrictStr] = Field(default=None, description="Effect of this rule. When `allow`, the rule allows the given actions to be performed on the given resources, subject to the given conditions. The only currently supported effect is `allow`.")
    principals: Optional[BucketAccessPolicyRulePrincipal] = Field(default=None, description="The principals to which this rule applies. Currently, only all principals are supported.")
    resources: Optional[conlist(StrictStr)] = Field(default=None, description="The list of resources which this rule applies to. The only currently supported resource is all objects in a bucket to which the parent policy belongs.")
    policy: Optional[FixedReference] = Field(default=None, description="The policy to which this rule belongs.")
    context: Optional[Reference] = Field(default=None, description="The context in which the operation was performed. Valid values include a reference to any array which is a member of the same fleet. If the array is not a member of a fleet, `context` will always implicitly be set to the array that received the request. Other parameters provided with the request, such as names of volumes or snapshots, are resolved relative to the provided `context`.")
    __properties = ["name", "actions", "effect", "principals", "resources", "policy", "context"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "effect",
                "context",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of principals
        if _include_in_dict('principals', include_readonly, excluded_fields, none_fields):
            _dict['principals'] = self.principals.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of policy
        if _include_in_dict('policy', include_readonly, excluded_fields, none_fields):
            _dict['policy'] = self.policy.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of context
        if _include_in_dict('context', include_readonly, excluded_fields, none_fields):
            _dict['context'] = self.context.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> BucketAccessPolicyRuleWithContext:
        """Create an instance of BucketAccessPolicyRuleWithContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> BucketAccessPolicyRuleWithContext:
        """Create an instance of BucketAccessPolicyRuleWithContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BucketAccessPolicyRuleWithContext.parse_obj(obj)

        _obj = BucketAccessPolicyRuleWithContext.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "actions": obj.get("actions"),
            "effect": obj.get("effect"),
            "principals": BucketAccessPolicyRulePrincipal.from_dict(obj.get("principals")) if obj.get("principals") is not None else None,
            "resources": obj.get("resources"),
            "policy": FixedReference.from_dict(obj.get("policy")) if obj.get("policy") is not None else None,
            "context": Reference.from_dict(obj.get("context")) if obj.get("context") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

