# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from pypureclient.flashblade.FB_2_17.models.fixed_reference import FixedReference


class LegalHoldHeldEntity(BaseModel):
    """
    LegalHoldHeldEntity
    """
    file_system: Optional[FixedReference] = Field(default=None, description="Reference to the file system that the legal hold is applied to.")
    legal_hold: Optional[FixedReference] = Field(default=None, description="Reference to the legal hold.")
    path: Optional[StrictStr] = Field(default=None, description="The path of the file or directory being held.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the legal hold with respect to the held entity. Valid values include: `applied` for holds that are actively applied, `applying` for holds that are being recursively applied but have not yet completed, `releasing` for holds that are being released recursively but have not yet completed. Entities that are releasing will no longer be held once this operation completes.")
    __properties = ["file_system", "legal_hold", "path", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of file_system
        if _include_in_dict('file_system', include_readonly, excluded_fields, none_fields):
            _dict['file_system'] = self.file_system.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of legal_hold
        if _include_in_dict('legal_hold', include_readonly, excluded_fields, none_fields):
            _dict['legal_hold'] = self.legal_hold.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> LegalHoldHeldEntity:
        """Create an instance of LegalHoldHeldEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> LegalHoldHeldEntity:
        """Create an instance of LegalHoldHeldEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LegalHoldHeldEntity.parse_obj(obj)

        _obj = LegalHoldHeldEntity.construct(_fields_set=None, **{
            "file_system": FixedReference.from_dict(obj.get("file_system")) if obj.get("file_system") is not None else None,
            "legal_hold": FixedReference.from_dict(obj.get("legal_hold")) if obj.get("legal_hold") is not None else None,
            "path": obj.get("path"),
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

