# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt


class NetworkInterfacesConnectorsSettingRocePfc(BaseModel):
    """
    Default PFC(Priority Flow Control) configuration for network connectors.
    """
    port_buffer: Optional[StrictInt] = Field(default=None, description="The buffer size in bytes reserved to absorb in-flight packets after XOFF threshold is reached.")
    xoff_threshold: Optional[StrictInt] = Field(default=None, description="The PFC XOFF threshold value in bytes. When the buffer for a particular traffic class reaches this threshold, the pause frame(XOFF) will be transimitted to the sender, requesting it to stop sending packets for that class.")
    xon_threshold: Optional[StrictInt] = Field(default=None, description="The PFC XON threshold value in bytes. When the buffer for a particular traffic class drops below this threshold, the un-pause frame(XON) will be transmitted to the sender, requesting it to resume sending packets for that class.")
    __properties = ["port_buffer", "xoff_threshold", "xon_threshold"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "port_buffer",
                "xoff_threshold",
                "xon_threshold",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> NetworkInterfacesConnectorsSettingRocePfc:
        """Create an instance of NetworkInterfacesConnectorsSettingRocePfc from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> NetworkInterfacesConnectorsSettingRocePfc:
        """Create an instance of NetworkInterfacesConnectorsSettingRocePfc from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NetworkInterfacesConnectorsSettingRocePfc.parse_obj(obj)

        _obj = NetworkInterfacesConnectorsSettingRocePfc.construct(_fields_set=None, **{
            "port_buffer": obj.get("port_buffer"),
            "xoff_threshold": obj.get("xoff_threshold"),
            "xon_threshold": obj.get("xon_threshold")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

