# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from pypureclient.flashblade.FB_2_17.models.reference import Reference


class OidcSsoPostIdp(BaseModel):
    """
    Identity Provider
    """
    provider_url: Optional[StrictStr] = Field(default=None, description="URL of the Identity Provider server")
    provider_url_ca_certificate: Optional[Reference] = Field(default=None, description="CA certificate used to validate the authenticity of the configured Identity Provider server.")
    provider_url_ca_certificate_group: Optional[Reference] = Field(default=None, description="A certificate group containing CA certificates that can be used to validate the authenticity of the configured Identity Provider server.")
    __properties = ["provider_url", "provider_url_ca_certificate", "provider_url_ca_certificate_group"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of provider_url_ca_certificate
        if _include_in_dict('provider_url_ca_certificate', include_readonly, excluded_fields, none_fields):
            _dict['provider_url_ca_certificate'] = self.provider_url_ca_certificate.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of provider_url_ca_certificate_group
        if _include_in_dict('provider_url_ca_certificate_group', include_readonly, excluded_fields, none_fields):
            _dict['provider_url_ca_certificate_group'] = self.provider_url_ca_certificate_group.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> OidcSsoPostIdp:
        """Create an instance of OidcSsoPostIdp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> OidcSsoPostIdp:
        """Create an instance of OidcSsoPostIdp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OidcSsoPostIdp.parse_obj(obj)

        _obj = OidcSsoPostIdp.construct(_fields_set=None, **{
            "provider_url": obj.get("provider_url"),
            "provider_url_ca_certificate": Reference.from_dict(obj.get("provider_url_ca_certificate")) if obj.get("provider_url_ca_certificate") is not None else None,
            "provider_url_ca_certificate_group": Reference.from_dict(obj.get("provider_url_ca_certificate_group")) if obj.get("provider_url_ca_certificate_group") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

