# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.3, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from pypureclient.flashblade.FB_2_3.models.support_remote_assist_paths import SupportRemoteAssistPaths


class Support(BaseModel):
    """
    Support
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    phonehome_enabled: Optional[StrictBool] = None
    proxy: Optional[StrictStr] = None
    remote_assist_active: Optional[StrictBool] = Field(default=None, description="The switch to open all remote-assist sessions.")
    remote_assist_expires: Optional[StrictStr] = Field(default=None, description="The time when the session expires.")
    remote_assist_opened: Optional[StrictStr] = Field(default=None, description="The time when the session opened.")
    remote_assist_paths: Optional[conlist(SupportRemoteAssistPaths)] = None
    remote_assist_status: Optional[StrictStr] = Field(default=None, description="The status of the remote-assist sessions. Valid values are `connected`, `partially_connected`, `reconnecting`, and `disconnected`.")
    __properties = ["id", "name", "phonehome_enabled", "proxy", "remote_assist_active", "remote_assist_expires", "remote_assist_opened", "remote_assist_paths", "remote_assist_status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
                "remote_assist_expires",
                "remote_assist_opened",
                "remote_assist_paths",
                "remote_assist_status",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in remote_assist_paths (list)
        if _include_in_dict('remote_assist_paths', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.remote_assist_paths:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['remote_assist_paths'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Support:
        """Create an instance of Support from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Support:
        """Create an instance of Support from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Support.parse_obj(obj)

        _obj = Support.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "phonehome_enabled": obj.get("phonehome_enabled"),
            "proxy": obj.get("proxy"),
            "remote_assist_active": obj.get("remote_assist_active"),
            "remote_assist_expires": obj.get("remote_assist_expires"),
            "remote_assist_opened": obj.get("remote_assist_opened"),
            "remote_assist_paths": [SupportRemoteAssistPaths.from_dict(_item) for _item in obj.get("remote_assist_paths")] if obj.get("remote_assist_paths") is not None else None,
            "remote_assist_status": obj.get("remote_assist_status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

