# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.6, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr


class Audit(BaseModel):
    """
    Audit
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    arguments: Optional[StrictStr] = None
    command: Optional[StrictStr] = None
    ip_address: Optional[StrictStr] = None
    subcommand: Optional[StrictStr] = None
    time: Optional[StrictInt] = None
    user: Optional[StrictStr] = None
    user_agent: Optional[StrictStr] = None
    user_interface: Optional[StrictStr] = Field(default=None, description="The user interface through which the user session event was performed. Valid values are `CLI`, `GUI`, and `REST`.")
    __properties = ["id", "name", "arguments", "command", "ip_address", "subcommand", "time", "user", "user_agent", "user_interface"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
                "arguments",
                "command",
                "ip_address",
                "subcommand",
                "time",
                "user",
                "user_agent",
                "user_interface",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Audit:
        """Create an instance of Audit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Audit:
        """Create an instance of Audit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Audit.parse_obj(obj)

        _obj = Audit.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "arguments": obj.get("arguments"),
            "command": obj.get("command"),
            "ip_address": obj.get("ip_address"),
            "subcommand": obj.get("subcommand"),
            "time": obj.get("time"),
            "user": obj.get("user"),
            "user_agent": obj.get("user_agent"),
            "user_interface": obj.get("user_interface")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

