# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.7, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.7
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr


class Alert(BaseModel):
    """
    Alert
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    action: Optional[StrictStr] = Field(default=None, description="The action of the alert.")
    code: Optional[StrictInt] = Field(default=None, description="Alert code.")
    component_name: Optional[StrictStr] = Field(default=None, description="The component name of the alert.")
    component_type: Optional[StrictStr] = Field(default=None, description="The component type of the alert.")
    created: Optional[StrictInt] = Field(default=None, description="The creation timestamp of the alert.")
    description: Optional[StrictStr] = Field(default=None, description="The description of the alert.")
    flagged: Optional[StrictBool] = Field(default=None, description="Flagged state of the alert.")
    index: Optional[StrictInt] = Field(default=None, description="The unique index of the alert.")
    knowledge_base_url: Optional[StrictStr] = Field(default=None, description="URL of the relevant Knowledge Base page.")
    notified: Optional[StrictInt] = Field(default=None, description="The last notification timestamp of the alert.")
    severity: Optional[StrictStr] = Field(default=None, description="Severity of the alert. Valid values are `info`, `warning`, and `critical`.")
    state: Optional[StrictStr] = Field(default=None, description="The current state of the alert. Valid values are `open`, `closing`, `closed`, and `waiting to downgrade`.")
    summary: Optional[StrictStr] = Field(default=None, description="The summary of the alert.")
    updated: Optional[StrictInt] = Field(default=None, description="The last updated timestamp of the alert.")
    variables: Optional[Dict[str, StrictStr]] = Field(default=None, description="Key-value pairs of additional information of the alert.")
    __properties = ["id", "name", "action", "code", "component_name", "component_type", "created", "description", "flagged", "index", "knowledge_base_url", "notified", "severity", "state", "summary", "updated", "variables"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
                "action",
                "code",
                "component_name",
                "component_type",
                "created",
                "description",
                "index",
                "knowledge_base_url",
                "notified",
                "severity",
                "state",
                "summary",
                "updated",
                "variables",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Alert:
        """Create an instance of Alert from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Alert:
        """Create an instance of Alert from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Alert.parse_obj(obj)

        _obj = Alert.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "action": obj.get("action"),
            "code": obj.get("code"),
            "component_name": obj.get("component_name"),
            "component_type": obj.get("component_type"),
            "created": obj.get("created"),
            "description": obj.get("description"),
            "flagged": obj.get("flagged"),
            "index": obj.get("index"),
            "knowledge_base_url": obj.get("knowledge_base_url"),
            "notified": obj.get("notified"),
            "severity": obj.get("severity"),
            "state": obj.get("state"),
            "summary": obj.get("summary"),
            "updated": obj.get("updated"),
            "variables": obj.get("variables")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

