# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.8, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.8
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr


class ArrayEradicationConfig(BaseModel):
    """
    ArrayEradicationConfig
    """
    eradication_delay: Optional[StrictInt] = Field(default=None, description="The file eradication delay is in milliseconds. Automatically eradicate destroyed filesystems and snapshots after the delay time. Valid values are `86400000` and any multiple of `86400000` in the range of `86400000` and `2592000000`. Any other values will be rounded down to the nearest multiple of `86400000`.")
    manual_eradication: Optional[StrictStr] = Field(default=None, description="Manual eradication status is applied on the array level. If status is all-disabled, you cannot eradicate buckets and file systems. If status is file-disabled then you can not eradicate files systems. If status is object-disabled then you can not eradicate buckets. If status is all-enabled then you can eradicate file systems and buckets. Values include `all-enabled`, `file-disabled`, `object-disabled`, and `all-disabled`.")
    __properties = ["eradication_delay", "manual_eradication"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "eradication_delay",
                "manual_eradication",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> ArrayEradicationConfig:
        """Create an instance of ArrayEradicationConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> ArrayEradicationConfig:
        """Create an instance of ArrayEradicationConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ArrayEradicationConfig.parse_obj(obj)

        _obj = ArrayEradicationConfig.construct(_fields_set=None, **{
            "eradication_delay": obj.get("eradication_delay"),
            "manual_eradication": obj.get("manual_eradication")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

