# coding: utf-8

"""
    Pure1 Public REST API

    Pure1 Public REST API, developed by [Pure Storage, Inc.](https://www.purestorage.com)   The Pure1 REST API 2.0 offers one single form of authentication: OAuth 2.0 via the [Token Exchange protocol](https://datatracker.ietf.org/doc/draft-ietf-oauth-token-exchange).  OAuth 2.0 is an open protocol to allow secure authorization in a simple and standard method from web, mobile, desktop and background applications.  Note that the [Authentication](#section/Authentication) section below mentions 'API Key' as the security scheme type. This is solely for the purpose of allowing testing this API with [Swagger UI](https://static.pure1.purestorage.com/api-swagger/index.html).  [Knowledge base reference documentation](https://support.purestorage.com/Pure1/Pure1_Manage/Pure1_Manage_-_REST_API/Pure1_Manage_-_REST_API__Reference)

    The version of the OpenAPI document: 1.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


_attribute_error_on_none = True

class __LazyModelLoader:
    def __init__(self, modname, attr):
        self._modname  = modname
        self._attr     = attr
        self._mod      = None

    def load(self):
        import importlib
        if self._mod is None:
            self._mod = importlib.__import__(self._modname, globals(), locals(), fromlist=[self._attr], level=1)
        return getattr(self._mod, self._attr)

__class_model_dict = { 
    'Alert': __LazyModelLoader('alert', 'Alert'),
    'AlertsGetResponse': __LazyModelLoader('alerts_get_response', 'AlertsGetResponse'),
    'AlertsResponse': __LazyModelLoader('alerts_response', 'AlertsResponse'),
    'Array': __LazyModelLoader('array', 'Array'),
    'ArrayGetResponse': __LazyModelLoader('array_get_response', 'ArrayGetResponse'),
    'ArrayResponse': __LazyModelLoader('array_response', 'ArrayResponse'),
    'Arrays': __LazyModelLoader('arrays', 'Arrays'),
    'ArraysBuiltIn': __LazyModelLoader('arrays_built_in', 'ArraysBuiltIn'),
    'ArraysResource': __LazyModelLoader('arrays_resource', 'ArraysResource'),
    'AssetAddress': __LazyModelLoader('asset_address', 'AssetAddress'),
    'AssetOrg': __LazyModelLoader('asset_org', 'AssetOrg'),
    'AssetSpace': __LazyModelLoader('asset_space', 'AssetSpace'),
    'AssetSpaceTotalUsedRatio': __LazyModelLoader('asset_space_total_used_ratio', 'AssetSpaceTotalUsedRatio'),
    'AssetUpgradeDetails': __LazyModelLoader('asset_upgrade_details', 'AssetUpgradeDetails'),
    'Audit': __LazyModelLoader('audit', 'Audit'),
    'AuditsGetResponse': __LazyModelLoader('audits_get_response', 'AuditsGetResponse'),
    'AuditsResponse': __LazyModelLoader('audits_response', 'AuditsResponse'),
    'BaseAddress': __LazyModelLoader('base_address', 'BaseAddress'),
    'Blade': __LazyModelLoader('blade', 'Blade'),
    'BladeArrayStatus': __LazyModelLoader('blade_array_status', 'BladeArrayStatus'),
    'BladeGetResponse': __LazyModelLoader('blade_get_response', 'BladeGetResponse'),
    'BladeResponse': __LazyModelLoader('blade_response', 'BladeResponse'),
    'Bucket': __LazyModelLoader('bucket', 'Bucket'),
    'BucketGetResponse': __LazyModelLoader('bucket_get_response', 'BucketGetResponse'),
    'BucketReplicaLink': __LazyModelLoader('bucket_replica_link', 'BucketReplicaLink'),
    'BucketReplicaLinkGetResponse': __LazyModelLoader('bucket_replica_link_get_response', 'BucketReplicaLinkGetResponse'),
    'BucketReplicaLinkResponse': __LazyModelLoader('bucket_replica_link_response', 'BucketReplicaLinkResponse'),
    'BucketResponse': __LazyModelLoader('bucket_response', 'BucketResponse'),
    'BuiltInAsOf': __LazyModelLoader('built_in_as_of', 'BuiltInAsOf'),
    'Controller': __LazyModelLoader('controller', 'Controller'),
    'ControllerGetResponse': __LazyModelLoader('controller_get_response', 'ControllerGetResponse'),
    'ControllerResponse': __LazyModelLoader('controller_response', 'ControllerResponse'),
    'CurrentMetric': __LazyModelLoader('current_metric', 'CurrentMetric'),
    'Directory': __LazyModelLoader('directory', 'Directory'),
    'DirectoryGetResponse': __LazyModelLoader('directory_get_response', 'DirectoryGetResponse'),
    'DirectoryResponse': __LazyModelLoader('directory_response', 'DirectoryResponse'),
    'Drive': __LazyModelLoader('drive', 'Drive'),
    'DriveArrayStatus': __LazyModelLoader('drive_array_status', 'DriveArrayStatus'),
    'DriveGetResponse': __LazyModelLoader('drive_get_response', 'DriveGetResponse'),
    'DriveResponse': __LazyModelLoader('drive_response', 'DriveResponse'),
    'Error': __LazyModelLoader('error', 'Error'),
    'ErrorErrors': __LazyModelLoader('error_errors', 'ErrorErrors'),
    'ErrorNoContext': __LazyModelLoader('error_no_context', 'ErrorNoContext'),
    'EvergreenForeverAndFoundationDetails': __LazyModelLoader('evergreen_forever_and_foundation_details', 'EvergreenForeverAndFoundationDetails'),
    'FileSystem': __LazyModelLoader('file_system', 'FileSystem'),
    'FileSystemGetResponse': __LazyModelLoader('file_system_get_response', 'FileSystemGetResponse'),
    'FileSystemReplicaLink': __LazyModelLoader('file_system_replica_link', 'FileSystemReplicaLink'),
    'FileSystemReplicaLinkGetResponse': __LazyModelLoader('file_system_replica_link_get_response', 'FileSystemReplicaLinkGetResponse'),
    'FileSystemReplicaLinkResponse': __LazyModelLoader('file_system_replica_link_response', 'FileSystemReplicaLinkResponse'),
    'FileSystemResponse': __LazyModelLoader('file_system_response', 'FileSystemResponse'),
    'FileSystemSnapshot': __LazyModelLoader('file_system_snapshot', 'FileSystemSnapshot'),
    'FileSystemSnapshotGetResponse': __LazyModelLoader('file_system_snapshot_get_response', 'FileSystemSnapshotGetResponse'),
    'FileSystemSnapshotResponse': __LazyModelLoader('file_system_snapshot_response', 'FileSystemSnapshotResponse'),
    'FixedReference': __LazyModelLoader('fixed_reference', 'FixedReference'),
    'FixedReferenceFqdn': __LazyModelLoader('fixed_reference_fqdn', 'FixedReferenceFqdn'),
    'Geolocation': __LazyModelLoader('geolocation', 'Geolocation'),
    'Hardware': __LazyModelLoader('hardware', 'Hardware'),
    'HardwareConnector': __LazyModelLoader('hardware_connector', 'HardwareConnector'),
    'HardwareConnectorGetResponse': __LazyModelLoader('hardware_connector_get_response', 'HardwareConnectorGetResponse'),
    'HardwareConnectorResponse': __LazyModelLoader('hardware_connector_response', 'HardwareConnectorResponse'),
    'HardwareGetResponse': __LazyModelLoader('hardware_get_response', 'HardwareGetResponse'),
    'HardwareResponse': __LazyModelLoader('hardware_response', 'HardwareResponse'),
    'Http': __LazyModelLoader('http', 'Http'),
    'InstallAddress': __LazyModelLoader('install_address', 'InstallAddress'),
    'Invoice': __LazyModelLoader('invoice', 'Invoice'),
    'InvoiceGetResponse': __LazyModelLoader('invoice_get_response', 'InvoiceGetResponse'),
    'InvoiceLine': __LazyModelLoader('invoice_line', 'InvoiceLine'),
    'InvoiceLineComponent': __LazyModelLoader('invoice_line_component', 'InvoiceLineComponent'),
    'InvoiceResponse': __LazyModelLoader('invoice_response', 'InvoiceResponse'),
    'LicenseResourceReference': __LazyModelLoader('license_resource_reference', 'LicenseResourceReference'),
    'MarketplacePartner': __LazyModelLoader('marketplace_partner', 'MarketplacePartner'),
    'Metric': __LazyModelLoader('metric', 'Metric'),
    'MetricAvailability': __LazyModelLoader('metric_availability', 'MetricAvailability'),
    'MetricGetResponse': __LazyModelLoader('metric_get_response', 'MetricGetResponse'),
    'MetricHistory': __LazyModelLoader('metric_history', 'MetricHistory'),
    'MetricHistoryGetResponse': __LazyModelLoader('metric_history_get_response', 'MetricHistoryGetResponse'),
    'MetricHistoryResponse': __LazyModelLoader('metric_history_response', 'MetricHistoryResponse'),
    'MetricResponse': __LazyModelLoader('metric_response', 'MetricResponse'),
    'NetworkInterface': __LazyModelLoader('network_interface', 'NetworkInterface'),
    'NetworkInterfaceGetResponse': __LazyModelLoader('network_interface_get_response', 'NetworkInterfaceGetResponse'),
    'NetworkInterfaceResponse': __LazyModelLoader('network_interface_response', 'NetworkInterfaceResponse'),
    'Nfs': __LazyModelLoader('nfs', 'Nfs'),
    'Oauth210TokenPost400Response': __LazyModelLoader('oauth210_token_post400_response', 'Oauth210TokenPost400Response'),
    'Oauth210TokenPost401Response': __LazyModelLoader('oauth210_token_post401_response', 'Oauth210TokenPost401Response'),
    'OauthTokenResponse': __LazyModelLoader('oauth_token_response', 'OauthTokenResponse'),
    'ObjectStoreAccount': __LazyModelLoader('object_store_account', 'ObjectStoreAccount'),
    'ObjectStoreAccountGetResponse': __LazyModelLoader('object_store_account_get_response', 'ObjectStoreAccountGetResponse'),
    'ObjectStoreAccountResponse': __LazyModelLoader('object_store_account_response', 'ObjectStoreAccountResponse'),
    'PageInfo': __LazyModelLoader('page_info', 'PageInfo'),
    'Pod': __LazyModelLoader('pod', 'Pod'),
    'PodGetResponse': __LazyModelLoader('pod_get_response', 'PodGetResponse'),
    'PodReplicaLink': __LazyModelLoader('pod_replica_link', 'PodReplicaLink'),
    'PodReplicaLinkGetResponse': __LazyModelLoader('pod_replica_link_get_response', 'PodReplicaLinkGetResponse'),
    'PodReplicaLinkResponse': __LazyModelLoader('pod_replica_link_response', 'PodReplicaLinkResponse'),
    'PodResponse': __LazyModelLoader('pod_response', 'PodResponse'),
    'Policy': __LazyModelLoader('policy', 'Policy'),
    'PolicyGetResponse': __LazyModelLoader('policy_get_response', 'PolicyGetResponse'),
    'PolicyMember': __LazyModelLoader('policy_member', 'PolicyMember'),
    'PolicyMembersGetResponse': __LazyModelLoader('policy_members_get_response', 'PolicyMembersGetResponse'),
    'PolicyMembersResponse': __LazyModelLoader('policy_members_response', 'PolicyMembersResponse'),
    'PolicyResponse': __LazyModelLoader('policy_response', 'PolicyResponse'),
    'PolicyRule': __LazyModelLoader('policy_rule', 'PolicyRule'),
    'Port': __LazyModelLoader('port', 'Port'),
    'PortGetResponse': __LazyModelLoader('port_get_response', 'PortGetResponse'),
    'PortResponse': __LazyModelLoader('port_response', 'PortResponse'),
    'ReplicaLink': __LazyModelLoader('replica_link', 'ReplicaLink'),
    'Resource': __LazyModelLoader('resource', 'Resource'),
    'ResourceNoName': __LazyModelLoader('resource_no_name', 'ResourceNoName'),
    'ResourceWithLocation': __LazyModelLoader('resource_with_location', 'ResourceWithLocation'),
    'ResourceWithLocations': __LazyModelLoader('resource_with_locations', 'ResourceWithLocations'),
    'Smb': __LazyModelLoader('smb', 'Smb'),
    'Subscription': __LazyModelLoader('subscription', 'Subscription'),
    'SubscriptionAllOfServiceDetails': __LazyModelLoader('subscription_all_of_service_details', 'SubscriptionAllOfServiceDetails'),
    'SubscriptionAsset': __LazyModelLoader('subscription_asset', 'SubscriptionAsset'),
    'SubscriptionAssetArray': __LazyModelLoader('subscription_asset_array', 'SubscriptionAssetArray'),
    'SubscriptionAssetArrayAdvancedSpace': __LazyModelLoader('subscription_asset_array_advanced_space', 'SubscriptionAssetArrayAdvancedSpace'),
    'SubscriptionAssetGetResponse': __LazyModelLoader('subscription_asset_get_response', 'SubscriptionAssetGetResponse'),
    'SubscriptionAssetResponse': __LazyModelLoader('subscription_asset_response', 'SubscriptionAssetResponse'),
    'SubscriptionGetResponse': __LazyModelLoader('subscription_get_response', 'SubscriptionGetResponse'),
    'SubscriptionLicense': __LazyModelLoader('subscription_license', 'SubscriptionLicense'),
    'SubscriptionLicenseAddOnSla': __LazyModelLoader('subscription_license_add_on_sla', 'SubscriptionLicenseAddOnSla'),
    'SubscriptionLicenseGetResponse': __LazyModelLoader('subscription_license_get_response', 'SubscriptionLicenseGetResponse'),
    'SubscriptionLicensePreRatio': __LazyModelLoader('subscription_license_pre_ratio', 'SubscriptionLicensePreRatio'),
    'SubscriptionLicenseResponse': __LazyModelLoader('subscription_license_response', 'SubscriptionLicenseResponse'),
    'SubscriptionResponse': __LazyModelLoader('subscription_response', 'SubscriptionResponse'),
    'SupportContract': __LazyModelLoader('support_contract', 'SupportContract'),
    'SupportContractGetResponse': __LazyModelLoader('support_contract_get_response', 'SupportContractGetResponse'),
    'SupportContractResponse': __LazyModelLoader('support_contract_response', 'SupportContractResponse'),
    'SustainabilityArray': __LazyModelLoader('sustainability_array', 'SustainabilityArray'),
    'SustainabilityArrayGetResponse': __LazyModelLoader('sustainability_array_get_response', 'SustainabilityArrayGetResponse'),
    'SustainabilityArrayResponse': __LazyModelLoader('sustainability_array_response', 'SustainabilityArrayResponse'),
    'SustainabilityAssessment': __LazyModelLoader('sustainability_assessment', 'SustainabilityAssessment'),
    'SustainabilityInsightArray': __LazyModelLoader('sustainability_insight_array', 'SustainabilityInsightArray'),
    'SustainabilityInsightArrayGetResponse': __LazyModelLoader('sustainability_insight_array_get_response', 'SustainabilityInsightArrayGetResponse'),
    'SustainabilityInsightArrayResponse': __LazyModelLoader('sustainability_insight_array_response', 'SustainabilityInsightArrayResponse'),
    'Tag': __LazyModelLoader('tag', 'Tag'),
    'TagGetResponse': __LazyModelLoader('tag_get_response', 'TagGetResponse'),
    'TagPut': __LazyModelLoader('tag_put', 'TagPut'),
    'TagResponse': __LazyModelLoader('tag_response', 'TagResponse'),
    'Target': __LazyModelLoader('target', 'Target'),
    'TargetGetResponse': __LazyModelLoader('target_get_response', 'TargetGetResponse'),
    'TargetResponse': __LazyModelLoader('target_response', 'TargetResponse'),
    'Tax': __LazyModelLoader('tax', 'Tax'),
    'TimeAware': __LazyModelLoader('time_aware', 'TimeAware'),
    'TimeInterval': __LazyModelLoader('time_interval', 'TimeInterval'),
    'Volume': __LazyModelLoader('volume', 'Volume'),
    'VolumeGetResponse': __LazyModelLoader('volume_get_response', 'VolumeGetResponse'),
    'VolumeResponse': __LazyModelLoader('volume_response', 'VolumeResponse'),
    'VolumeSnapshot': __LazyModelLoader('volume_snapshot', 'VolumeSnapshot'),
    'VolumeSnapshotGetResponse': __LazyModelLoader('volume_snapshot_get_response', 'VolumeSnapshotGetResponse'),
    'VolumeSnapshotResponse': __LazyModelLoader('volume_snapshot_response', 'VolumeSnapshotResponse'),
}

def __getattr__(name, default=None):
    if '_models_list' == name:
        return __class_model_dict.keys()
    if name not in __class_model_dict:
        raise AttributeError(f'module {__name__} has no attribute {name}')
    return __class_model_dict[name].load()
