# coding: utf-8

"""
    Pure1 Public REST API

    Pure1 Public REST API, developed by [Pure Storage, Inc.](https://www.purestorage.com)   The Pure1 REST API 2.0 offers one single form of authentication: OAuth 2.0 via the [Token Exchange protocol](https://datatracker.ietf.org/doc/draft-ietf-oauth-token-exchange).  OAuth 2.0 is an open protocol to allow secure authorization in a simple and standard method from web, mobile, desktop and background applications.  Note that the [Authentication](#section/Authentication) section below mentions 'API Key' as the security scheme type. This is solely for the purpose of allowing testing this API with [Swagger UI](https://static.pure1.purestorage.com/api-swagger/index.html).  [Knowledge base reference documentation](https://support.purestorage.com/Pure1/Pure1_Manage/Pure1_Manage_-_REST_API/Pure1_Manage_-_REST_API__Reference)

    The version of the OpenAPI document: 1.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from pypureclient.pure1.Pure1_1_4.models.asset_space import AssetSpace
from pypureclient.pure1.Pure1_1_4.models.subscription_asset_array_advanced_space import SubscriptionAssetArrayAdvancedSpace


class SubscriptionAssetArray(BaseModel):
    """
    SubscriptionAssetArray
    """
    advanced_space: Optional[SubscriptionAssetArrayAdvancedSpace] = Field(default=None, description="The physical and effective space information. Only visible when the query parameter `advanced_space` is set to `true`.")
    chassis_serial_number: Optional[StrictStr] = Field(default=None, description="The chassis serial number of the appliance.")
    model: Optional[StrictStr] = Field(default=None, description="The model of the appliance.")
    space: Optional[AssetSpace] = Field(default=None, description="Displays size and space consumption information. For Evergreen//One and Evergreen//Flex this is the effective space information. For Evergreen//Forever and Evergreen//Foundation this is the physical space information.")
    version: Optional[StrictStr] = Field(default=None, description="The Purity version of the appliance.")
    __properties = ["advanced_space", "chassis_serial_number", "model", "space", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "chassis_serial_number",
                "model",
                "version",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of advanced_space
        if _include_in_dict('advanced_space', include_readonly, excluded_fields, none_fields):
            _dict['advanced_space'] = self.advanced_space.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of space
        if _include_in_dict('space', include_readonly, excluded_fields, none_fields):
            _dict['space'] = self.space.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionAssetArray:
        """Create an instance of SubscriptionAssetArray from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionAssetArray:
        """Create an instance of SubscriptionAssetArray from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionAssetArray.parse_obj(obj)

        _obj = SubscriptionAssetArray.construct(_fields_set=None, **{
            "advanced_space": SubscriptionAssetArrayAdvancedSpace.from_dict(obj.get("advanced_space")) if obj.get("advanced_space") is not None else None,
            "chassis_serial_number": obj.get("chassis_serial_number"),
            "model": obj.get("model"),
            "space": AssetSpace.from_dict(obj.get("space")) if obj.get("space") is not None else None,
            "version": obj.get("version")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

